import {
  select,
  json,
  tsv,
  geoPath,//data path to svg path
  geoEquirectangular,
  //geoMercator,
  zoom,
  event
} from 'd3';
import { feature } from 'topojson';//convert topojson to geojson

const svg = select('svg');


/*let selectcountry=null;
const onClick= id=>{selectcountry=id;
render();};
*/


const projection = geoEquirectangular(); //changed map  
const pathGenerator = geoPath().projection(projection);

const g = svg.append('g');

g.append('path')
    .attr('class', 'sphere')
    .attr('d', pathGenerator({type: 'Sphere'}));

svg.call(zoom().on('zoom', () => {
  g.attr('transform', event.transform);
}));

Promise.all([
  tsv('https://unpkg.com/world-atlas@1.1.4/world/50m.tsv'),
  json('https://unpkg.com/world-atlas@1.1.4/world/50m.json')//from world atlas
]).then(([tsvData, topoJSONdata]) => {
  
  const countryName = tsvData.reduce((accumulator, d) => {
    accumulator[d.iso_n3] = d.name;
    return accumulator;
  }, {});
  
 
  const Eco = {}; // economic status of the country
  tsvData.forEach(d => {
    Eco[d.iso_n3] = d.economy;
  });
  
/*function ecoadd(a,b) { return a + '' + b };  
function detail (d) {
return countryName[d.id]+'\n'+Eco[d.id] };.*/
  
  
  const cont = {}; // continent of the country
  tsvData.forEach(d => {
    cont[d.iso_n3] = d.continent;
  });
  
  const countries = feature(topoJSONdata, topoJSONdata.objects.countries);
  g.selectAll('path').data(countries.features)
    .enter().append('path')
      .attr('class', 'country')
      .attr('d', pathGenerator)
    .append('title')
      //.text(detail);
  .text( function(d){return countryName[d.id]+
    ', ' + cont[d.id] 
    + '\n'+Eco[d.id]; // broader economic position 
  });  
});